明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2366|回复: 7

三个vba开发的问题

[复制链接]
发表于 2004-9-2 12:52:00 | 显示全部楼层 |阅读模式
问题1:
distance=thisdrawing.utility.getinteger("默认值为10")
如果不输入数字,直接按enter
会出现“需要整数值,或选项关键字”的提示
请问:如何使得按enter后,使用自己的默认值继续往下执行 问题2:
GetEntity、GetInteger、GetKeyword执行时,按Esc,如何跳出下面的程序,重回AutoCAD命令界面(即要求输入时,如我想退出,如何办?)。但是,输入其他类型数据,仍然提示错误,要求重新输入,只有Esc可以退出程序? 问题3:
enAng = ThisDrawing.Utility.AngleFromXAxis(ThisDrawing.Utility.GetPoint, ThisDrawing.Utility.GetPoint)
该函数执行时,返回的角度不是和x轴的夹角,请问是什么原因???? 请大家多多指点
 楼主| 发表于 2004-9-2 18:44:00 | 显示全部楼层
大家帮忙啊!!!


此外,有没有用vba开发的,计算两个圆交点的程序段啊???还有圆与直线相交计算交点的程序段啊???
发表于 2004-9-2 20:37:00 | 显示全部楼层
尝试捕获错误,获得错误号,然后针对错误号处理。
发表于 2004-9-2 21:14:00 | 显示全部楼层
1.
  1. Sub Example_GetInt()
  2.       
  3.        On Error Resume Next
  4.       
  5.        ThisDrawing.Utility.InitializeUserInput 128
  6.       
  7.        Dim returnInt As Integer
  8.        returnInt = ThisDrawing.Utility.GetInteger(vbCr & "请输入数值<10>: ")
  9.        If Err Then
  10.                  If StrComp(Err.Number, -2145320928, 1) = 0 Then
  11.                          Dim inputString As String
  12.                          Err.Clear
  13.                          inputString = ThisDrawing.Utility.GetInput
  14.                          If inputString = "" Then
  15.                                MsgBox "你输入的是默认值10", , "明经通道VBA示例"
  16.                                returnInt = 10
  17.                        Else
  18.                                MsgBox "你输入了关键字为: " & inputString
  19.                        End If
  20.                  Else
  21.                          MsgBox "出错了: " & Err.Description
  22.                          Err.Clear
  23.                  End If
  24.        Else
  25.                MsgBox "输入的整数为: " & returnInt, , "明经通道VBA示例"
  26.        End If
  27.       
  28. End Sub
发表于 2004-9-2 22:17:00 | 显示全部楼层
1、2是同一个问题


3、是与X轴的夹角


另外,IntersectWith函数
发表于 2004-9-2 22:43:00 | 显示全部楼层
这是我的一个数据输入的子程序,对你的问题有帮助 Public Function Fun图形数据输入(TmpMsg As String, WhatType As CadInputType, HasNothing As Boolean) As Variant
Dim xTmp As Variant, DefVal As String, i As Integer, j As Integer
i = InStr(TmpMsg, "<"): j = InStr(TmpMsg, ">")
If i > 0 And j > 0 Then DefVal = Mid(TmpMsg, i + 1, j - i - 1)
On Error Resume Next
Aa:
Select Case WhatType
Case 1 'inputAngle = 1
xTmp = -99999
xTmp = ThisDrawing.Utility.GetAngle(, TmpMsg)
If xTmp = -99999 Then If Not HasNothing Then GoTo Aa Else xTmp = IIf(IsNumeric(DefVal), CInt(DefVal), 0)
Case 2 'inputDistance = 2
xTmp = -99999
xTmp = ThisDrawing.Utility.GetDistance(, TmpMsg)
If xTmp = -99999 Then If Not HasNothing Then GoTo Aa Else xTmp = IIf(IsNumeric(DefVal), CDbl(DefVal), 0)
Case 3 'inputInteger = 3
xTmp = -99999
xTmp = ThisDrawing.Utility.GetInteger(TmpMsg)
If xTmp = -99999 Then If Not HasNothing Then GoTo Aa Else xTmp = IIf(IsNumeric(DefVal), CInt(DefVal), 0)
Case 4 'inputKeyword = 4
xTmp = ThisDrawing.Utility.GetKeyword(TmpMsg)
'If xTmp Is Empty And Not HasNothing Then GoTo Aa
Case 5 'inputPoint = 5
Dim xD(2) As Double, sPnt As Variant, tD() As Double
xD(0) = -99999: xD(1) = -99999: ReDim tD(2)
xTmp = xD
If Not DefVal = "" Then Call PntStrToDat(DefVal, tD)
ReDim Preserve tD(2): sPnt = tD
Beep
TmpMsg = Replace(TmpMsg, "<" + DefVal + ">", "")
xTmp = ThisDrawing.Utility.GetPoint(sPnt, TmpMsg)
If xTmp(0) = -99999 And xTmp(1) = -99999 Then If Not HasNothing Then GoTo Aa
Case 6 'inputReal = 6
xTmp = -99999
xTmp = ThisDrawing.Utility.GetReal(TmpMsg)
If xTmp = -99999 Then If Not HasNothing Then GoTo Aa Else xTmp = DefVal
Case 7 'inputString = 7
xTmp = ThisDrawing.Utility.GetString(0, TmpMsg)
If xTmp = "" Then If Not HasNothing Then GoTo Aa Else xTmp = DefVal
End Select
Fun图形数据输入 = xTmp
End Function
 楼主| 发表于 2004-9-4 13:46:00 | 显示全部楼层
太感谢大家了!!!!!


我会试一下的!!!!


另外为什么网页保存不了啊???
 楼主| 发表于 2004-9-11 08:21:00 | 显示全部楼层
问题1的解决:


我在distance=thisdrawing.utility.getinteger("默认值为10")前面用默认值给distance赋值,然后利用on error resume next的忽略错误功能继续执行...这个方法还可以..当然,用大家的扑捉错误也可以,不过,,if语句嵌套的太多了(我前面也用了好多if)


问题2的又一个疑问:


GetEntity函数:当这个函数等待用户选择时,按esc和选不中对象的err.number数值是一样的,,,真是不晓得,如何对按esc和选不中对象分别编写不同的错误处理程序了???大家知道吗???????


问题3的解释:


AngleFromXAxis返回弧度值,而不是角度.......


另外,想问大家,弧度的起点是x轴,请问,用什么去判断到底是顺时针为正,还是逆时针为正????????????????
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-28 02:44 , Processed in 0.194636 second(s), 23 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表